% TAHA BABAEI
%darajate azadi baraye Frame be in surat darnazar migirim k avval ofoghiha baraye kolle gereh ha va sepas ghaem ha va nahayatan davaraniha(langariha) baraye kolle gereh ha vared mishavand.baraye har eleman ham jahate har eleman(ebteda va enteha) az chap be rast baraye elemanhaye ofoghi va az pain be bala baraye elemanhaye ghaem va baraye elemanhaye movarrab niz az pain be bala.darajate azadi ra baraye kharpa be in surat darnazar begirid k az gerehye 1 shoru konid va be garehye payani beresid.ya'ni daraje azadiye ofaghiye gerehye 1 ra U1 va gha'emash ra U2 va daraje azadiye ofoghiye gerehye 2 ra U3 va gha'emash ra U4 va baraye gerehye 3 niz betartib ofoghi va gha'em ra U5 va U6 va ela akhar ta be akharin gereh beresin.ra'ayate in namgozari ELZAMI ast zira matrixe sakhti bar asase in namgozariye gereha darnazar gerefte shode ast.        
clear all;clc;close all;%pak kardane tamame moteghayerha va panjereye dasturat va panjerehaye baze dige mesle figure belafasele badaz ejraye barname
format short%deghghate namayeshe a'dad ra ta 15 ragham ba'd az a'shar mikonad
disp '"Welcome"';
pause(2);
disp '"Thank You For Using This Program To Analysis Your 2D Frame & 2D Truss By Finite Element Method"';
pause(3);
disp '"This Program Is Writed By TAHA BABAEI"';
pause(4);
question=input(sprintf('Your Problem Is Frame Or Truss (Frame/Truss)?  '),'s');
disp ' '
disp('please wait ...')
if question=='Truss'
disp(' ')
TRUSSINPUTES=xlsread('TRUSS.xlsx');%khandane file e excel e marbut be kharpaye mojud dar pusheye barnameh.lazem be zekr ast ba in dastur barnameye matlab file e excele marbuteh ra besurate ye matrix baz mikonad va mitavan tamame amaliat haye marbut be matrix ha ra ruye in file anjam dad k dar edame karbord khahand dasht.hamchenin az in khat be ba'd barname dige ba file e excel kari nadare zira an ra ba esme TRUSSINPUTES dar khod negah midarad va harja k ebarate TRUSSINPUTES ra moshahede kardid darvaghe mohtavaye haman file e excel mibashad.
ElementNum=TRUSSINPUTES(1,1);%khandane te'dade elemanha az file e excel
NodeNum=TRUSSINPUTES(1,2);%khandane te'dade gereh ha az file e excel
U0Num=TRUSSINPUTES(1,3);%khandane te'dade darajate azadiye gheyre fa'al az file e excel
EMatrix=TRUSSINPUTES(1:ElementNum,4);%khandane sotune marbut be zaribe Elasticity az file e excel
AMatrix=TRUSSINPUTES(1:ElementNum,5);%khandane sotune marbut be sathe maghta'e elemanha az file e excel
ElementNodes=TRUSSINPUTES(1:ElementNum,8:9);%khandane sotunhaye marbut be jahate har eleman (gereh haye ebteda va entehaye har eleman) az file e excel
NodeCoordinates=TRUSSINPUTES(1:NodeNum,10:11);%khandane sotunhaye marbut be mokhtasate gereh ha az file e excel
xx=NodeCoordinates(:,1);%mokhtasate X e tamame gereh hara dar yek matrix be esme xx negah midarad
yy=NodeCoordinates(:,2);%mokhtasate Y e tamame gereh hara dar yek matrix be esme yy negah midarad

% SHOW SIMPLE FIGURE OF YOUR TRUSS
for j=1:ElementNum
    X=[NodeCoordinates(ElementNodes(j,:),1)];%hasele ebarate ElementNodes(j,:) 2ta adad(shomareye 2ta gereh) ast k darune yek matrix mibashand(ElementNodes(j,:)=[a b])
    Y=[NodeCoordinates(ElementNodes(j,:),2)];
    hold on%hold on:tamame sheklha ra tuye yek panjereye figure baz mikonad
    absxx=abs(xx);%abs(a) ya'ni tamame derayehaye matrixe a ra ghadremotlagheshan ra minevisad(tamame derayehaye matrixe a ra mosbat mikonad)
    absyy=abs(yy);%az khatte 29-35 baraye moshakhas kardane hodude mehvarhaye mokhtasat ast
    maxxx=max(absxx);
    maxyy=max(absyy);
    maxi=max([maxxx maxyy]);
    xlim([-2*maxi 2*maxi])%xlim:mahdudeye mehvare x ha (X axis) ra motenaseb ba har mesal moshakhas mikonad
    ylim([-2*maxi 2*maxi])%ylim:mahdudeye mehvare y ha (Y axis) ra motenaseb ba har mesal moshakhas mikonad
    plot(X,Y,'m','linewidth',12)
    plot(X,Y,'o','linewidth',6)
    grid on
    xlabel('X axis \rightarrow')
    ylabel('Y axis \rightarrow')
    title('Simple Figure Of Your Truss','fontsize',15)
end
for a=1:NodeNum%in halghe ya loop baraye neveshtane shomareye har gereh ruye an gereh dar shekl ast.
     nodes=(num2str(a));%num2str(a):adade a ra tabdil be yek karaktere reshtei mikonad,ya'ni narmafzar farz mikonad k adade a ye karaktere reshtei mesle horufe alefba ast.
      text(NodeCoordinates(a,1),NodeCoordinates(a,2),nodes,'VerticalAlignment','bottom','HorizontalAlignment','right')
end
for b=1:ElementNum%in halghe baraye neveshtane shomareye har eleman ruyash ast.
    Xe=[NodeCoordinates(ElementNodes(b,:),1)];
    Ye=[NodeCoordinates(ElementNodes(b,:),2)];
    Xm=sum(Xe)/2;
    Ym=sum(Ye)/2;
    elementname=(num2str(b));
    text(Xm,Ym,elementname)
end
AllDof=2*NodeNum;
U=zeros(AllDof,1);
force=zeros(AllDof,1);
force=TRUSSINPUTES(1:AllDof,6);

%SHOW SIMPLE FIGURE OF YOUR LOADING
for i=1:2:AllDof%baraye bargozarihaye ofoghi(hamegi daraye shomarehaye fard hastand)
    B=[1:2:AllDof];
    BAR=force(i);%BAR ra mosavi gharar bede ba meghdare derayeye i ome matrixe bargozari.
    if BAR~=0
        n=find(B==i);%n=find(a==k) yani az matrixe [a] shomareye an derayeh'i k barabar ba meghdare 'k' ast ra mosavi ba 'n' gharar bede{agar bejaye 'n' [m,n] bud yani satr va sotunash ra barabar ba betartib 'n' va 'm' gharar bede.mosallaman n barabar ba yeki az a'dade 1 ta NodeNum dar mi'ayad dar hamin khat zira in khat dar surati barrasi mishavad ke bar dar solse(1/3)ebteda'iye matrixe AllDof(dareje azadiha) bashad
        XL=[NodeCoordinates(n,1),NodeCoordinates(n,1)+0.25*maxi];
        YL=[NodeCoordinates(n,2),NodeCoordinates(n,2)];
        plot(XL,YL,'linewidth',2)
    end
end
for i=2:2:AllDof%baraye bargozarihaye ghaem(hamegi daraye shomarehaye zoj hastand)
    B=[2:2:AllDof];
    BAR=force(i);%BAR ra mosavi gharar bede ba meghdare derayeye i ome matrixe bargozari.
    if BAR~=0
        n=find(B==i);%n=find(a==k) yani az matrixe [a] shomareye an derayeh'i k barabar ba meghdare 'k' ast ra mosavi ba 'n' gharar bede{agar bejaye 'n' [m,n] bud yani satr va sotunash ra barabar ba betartib 'n' va 'm' gharar bede.mosallaman n barabar ba yeki az a'dade 1 ta NodeNum dar mi'ayad dar hamin khat zira in khat dar surati barrasi mishavad ke bar dar solse(1/3)ebteda'iye matrixe AllDof(dareje azadiha) bashad.(n:shomareye gerehi ast ke bar ruye an gharar darad)
        XL=[NodeCoordinates(n,1),NodeCoordinates(n,1)];
        YL=[NodeCoordinates(n,2),NodeCoordinates(n,2)+0.25*maxi];
        plot(XL,YL,'linewidth',2);
    end
end

%matrixe sakhti (stiffness matrix)
stiffness=zeros(AllDof);
for e=1:ElementNum%halgheye marbut be mohasebeye sakhtiye har eleman(in halghe baraye tamame elemanha ejra mishavad)
    E=EMatrix(e);%(e omin derayeh az matrixe EMatrix haman zaribe elasticity baraye elemane e om mibashad)
    A=AMatrix(e);%(e omin derayeh az matrixe AMatrix haman sathe maghtae elemane e om mibashad)
    EA=E*A;
    ElementCourse=ElementNodes(e,:);%ElementCourse=ebteda va entehaye eleman(gerehye ebteda va gerehye entehaiye eleman)
    ElementDof=[[2*ElementNodes(e,1)-1] [2*ElementNodes(e,1)] [2*ElementNodes(e,2)-1] [2*ElementNodes(e,2)]];
    xa=xx(ElementCourse(2))-xx(ElementCourse(1));
    ya=yy(ElementCourse(2))-yy(ElementCourse(1));
    length_element=sqrt(xa*xa+ya*ya);
    cosinus=xa/length_element;
    sinus=ya/length_element;
    ll=length_element;
    tetta=atan(ya/xa);
    %T=[cosinus,sinus,0,0;-sinus,cosinus,0,0;0,0,cosinus,sinus;0,0,-sinus,cosinus]%T:matrixe tabdil mibashad baraye elemanhai k zaviye dar ya ghaemand.eye(2);matrixi morabba'i ba ab'ade 2*2 k drayehaye a11 va a22 ash 1 mibashand dorost mikonad.(eye(n,m):matrixi be ab'ade n*m k drayehaye a11,a22,...,ann ash (derayehaye ruye ghotre asliash) 1 mibashad va sayere derayehahash 0 mibashad)(matrixe VAHED)
    k=(EA/ll)*[cosinus^2,0.5*sin(2*tetta),-cosinus^2,-0.5*sin(2*tetta);0.5*sin(2*tetta),sinus^2,-0.5*sin(2*tetta),-sinus^2;-cosinus^2,-0.5*sin(2*tetta),cosinus^2,0.5*sin(2*tetta);-0.5*sin(2*tetta),-sinus^2,0.5*sin(2*tetta),sinus^2];%in matrixe [k] khodash ba ta'sire matrixe tabdile T neveshte shodeh va baraye mohasebeye matrixe sakhtiye kolle sazeh niazi be ta'sir dadane T va T' besurate(k=T'*k*T)ruye matrixe sakhtiye har eleman(k) nis.
    stiffness(ElementDof,ElementDof)=stiffness(ElementDof,ElementDof)+k;
Ke(1:4,e*4-3:e*4)=k;%Ke:matrixe zakhireh,jahate zakhiresazie matrix haye sakhtie tamame elemanha(baraye mohasebeye nirihaye dakhelie har eleman be matrixe sakhtie an eleman niaz darim k az matrixe zakhire an ra birun mikeshim)
end

% boundary conditions(sharayete marzi)
DeactivedDof=TRUSSINPUTES(1:U0Num,7);%sotune marbut be DeactivedDof dar file ec excel ra khande va ba hamin esm namgozari mikonad

%anjame sayere mohasebat
activeDof=setdiff([1:AllDof]', [DeactivedDof]);%setdiff(A,B):anasori az bordare([matrixe] ya {majmueye}) A ra ke dar bordare B vojud nadarand neshan midahad.(az kolle darajate azadi anhai k 0 mishavand ra kam mikonad va darajate azadiye gheyre sefr ra neshan midahad(moshakhas mikonad)
U=stiffness(activeDof,activeDof)\force(activeDof);
Displacements=zeros(AllDof,1);
Displacements(activeDof)=U;

%namayeshe khorujiha
disp('***Displacement***')
NNode=1:AllDof;
[NNode' Displacements]
F=stiffness*Displacements;%F=KU
reactions=F(DeactivedDof);
disp('***Reactions***')
[DeactivedDof reactions]

%Internal Forces
for p=1:ElementNum%in halghe baraye mohasebeye matrixe jabejaiye har eleman mibashad
    Ut=Displacements;
    u1=Ut(2*ElementNodes(p,1)-1);%jabejaiye ofoghi ruye gerehye ebtedaye har eleman
    u2=Ut(2*ElementNodes(p,1));%jabejaiye ofoghi ruye gerehye entehaye har eleman
    u3=Ut(2*ElementNodes(p,2)-1);%jabejaiye ghaem ruye gerehye ebtedaye har eleman
    u4=Ut(2*ElementNodes(p,2));%jabejaiye ghaem ruye gerehye entehaye har eleman
    disp('Internal Force,Stiffness and Displacement Matrix For Element');disp(p)
    ue=[u1;u2;u3;u4]%matrixe jabejaiye har eleman 
    ke=Ke(1:4,p*4-3:p*4)%matrixe sakhtiye har eleman
    fe=ke*ue%matrixe niruhaye dakheliye har eleman
    disp('- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -')
end
disp('A N A L Y S I S   C O M P L E T E ')
disp(datestr(clock))
save('Truss Displacements.txt','Displacements','-ascii')
save('Truss Reactions.txt','reactions','-ascii')

elseif question=='Frame'
global Ke L reactions;%global:dasturi ast ke moteghayyerhaye ruberuyash ra be onvane moteghayyerhaye asli,sarasari,omumi mishnase va anhara harja k bashand darune workspace zakhire mikonad
disp ' '
FRAMEINPUTES=xlsread('FRAME.xlsx');
ElementNum=FRAMEINPUTES(1,1);%ElementNum:te'dade elemanha
NodeNum=FRAMEINPUTES(1,2);%NodeNum:te'dade gereh ha
U0Num=FRAMEINPUTES(1,3);
EMatrix=FRAMEINPUTES(1:ElementNum,4);%E:modulus of elasticity(matrixe zaribe elastisiteha.be in surat ke be tartib E e elemanhara ra be tartib dar yek matrixe sotuni vared mikonim(E1=Ee elemane 1,E2=E e elemane 2))
AMatrix=FRAMEINPUTES(1:ElementNum,5);%A:area of cross section(matrixe masahate sathe maghta'ha.)
IMatrix=FRAMEINPUTES(1:ElementNum,6);%I:maman 'inersi(matrixe langare dovome sath(maman inersi))
ElementNodes=FRAMEINPUTES(1:ElementNum,9:10);%ElementNodes:matrixi ke dar an gereh haye tashkil dahandeye har eleman moshakhas mishavad(ebteda va entehaye har eleman)
NodeCoordinates=FRAMEINPUTES(1:NodeNum,11:12);%NodeCoordinates:matrixi ke dar an mokhtasate haryek az gereh ha be tartib vared mishavad
xx=NodeCoordinates(:,1);%xx=matrixi ke birun keshide shode az matrixe NodeCoordinates ast be in surat ke az tamame satrhaye matrixe NodeCoordinates faghat sotune 1 estekhraj shavad
yy=NodeCoordinates(:,2);%yy=matrixi ke birun keshide shode az matrixe NodeCoordinates ast be in surat ke az tamame satrhaye matrixe NodeCoordinates faghat sotune 2 estekhraj shavad

% SHOW SIMPLE FIGURE OF YOUR FRAME
for j=1:ElementNum
    X=[NodeCoordinates(ElementNodes(j,:),1)];%hasele ebarate ElementNodes(j,:) 2ta adad(shomareye 2ta gereh) ast k darune yek matrix mibashand(ElementNodes(j,:)=[a b])
    Y=[NodeCoordinates(ElementNodes(j,:),2)];
    hold on%hold on:tamame sheklha ra tuye yek panjereye figure baz mikonad
    absxx=abs(xx);%abs(a) ya'ni tamame derayehaye matrixe a ra ghadremotlagheshan ra minevisad(tamame derayehaye matrixe a ra mosbat mikonad)
    absyy=abs(yy);%az khatte 25-32 baraye moshakhas kardane hodude mehvarhaye mokhtasat ast
    maxxx=max(absxx);
    maxyy=max(absyy);
    maxi=max([maxxx maxyy]);
    xlim([-2*maxi 2*maxi])%xlim:mahdudeye mehvare x ha (X axis) ra motenaseb ba har mesal moshakhas mikonad
    ylim([-2*maxi 2*maxi])%ylim:mahdudeye mehvare y ha (Y axis) ra motenaseb ba har mesal moshakhas mikonad
    plot(X,Y,'m','linewidth',12)
    plot(X,Y,'o','linewidth',6)
    grid on
    xlabel('X axis \rightarrow')
    ylabel('Y axis \rightarrow')
    title('Simple Figure Of Your Frame','fontsize',15)
end
for a=1:NodeNum%in halghe ya loop baraye neveshtane shomareye har gereh ruye an gereh dar shekl ast.
     nodes=(num2str(a));%num2str(a):adade a ra tabdil be yek karaktere reshtei mikonad,ya'ni narmafzar farz mikonad k adade a yek karaktere reshtei mesle horufe alefba ast.
      text(NodeCoordinates(a,1),NodeCoordinates(a,2),nodes,'VerticalAlignment','bottom','HorizontalAlignment','right')
end
for b=1:ElementNum%in halghe baraye neveshtane shomareye har eleman ruyash ast.
    Xe=[NodeCoordinates(ElementNodes(b,:),1)];
    Ye=[NodeCoordinates(ElementNodes(b,:),2)];
    Xm=sum(Xe)/2;
    Ym=sum(Ye)/2;
    elementname=(num2str(b));
    text(Xm,Ym,elementname)
end
AllDof=3*NodeNum;%AllDof:te'dade darajate azadi(be ezaye har gereh 3ta)
U=zeros(AllDof,1);%U:jabejai:barabar ast ba matrixe sefri ke tedad satrhayash barabare meghdare AllDof va tedad sotunhayash barabare 1 ast.be in dalil meghdare U ra chenin matrixe sefri midahim k chon badan be in sefrha a'dadi ezafe va darvaghe janeshin khahand shod
force=zeros(AllDof,1);
force=FRAMEINPUTES(1:AllDof,7);

%SHOW SIMPLE FIGURE OF YOUR LOADING
for i=1:NodeNum%baraye bargozarihaye ofoghi
    B=[1:NodeNum];
    BAR=force(i);%BAR ra mosavi gharar bede ba meghdare derayeye i ome matrixe bargozari.
    if BAR~=0
        n=find(B==i);%n=find(a==k) yani az matrixe [a] shomareye an derayeh'i k barabar ba meghdare 'k' ast ra mosavi ba 'n' gharar bede{agar bejaye 'n' [m,n] bud yani satr va sotunash ra barabar ba betartib 'n' va 'm' gharar bede.mosallaman n barabar ba yeki az a'dade 1 ta NodeNum dar mi'ayad dar hamin khat zira in khat dar surati barrasi mishavad ke bar dar solse(1/3)ebteda'iye matrixe AllDof(dareje azadiha) bashad
        XL=[NodeCoordinates(n,1),NodeCoordinates(n,1)+0.25*maxi];
        YL=[NodeCoordinates(n,2),NodeCoordinates(n,2)];
        plot(XL,YL,'linewidth',2)
    end
end
for i=NodeNum+1:2*NodeNum%baraye bargozarihaye ghaem
    B=[NodeNum+1:2*NodeNum];
    BAR=force(i);%BAR ra mosavi gharar bede ba meghdare derayeye i ome matrixe bargozari.
    if BAR~=0
        n=find(B==i)%n=find(a==k) yani az matrixe [a] shomareye an derayeh'i k barabar ba meghdare 'k' ast ra mosavi ba 'n' gharar bede{agar bejaye 'n' [m,n] bud yani satr va sotunash ra barabar ba betartib 'n' va 'm' gharar bede.mosallaman n barabar ba yeki az a'dade 1 ta NodeNum dar mi'ayad dar hamin khat zira in khat dar surati barrasi mishavad ke bar dar solse(1/3)ebteda'iye matrixe AllDof(dareje azadiha) bashad.(n:shomareye gerehi ast ke bar ruye an gharar darad)
        XL=[NodeCoordinates(n,1),NodeCoordinates(n,1)];
        YL=[NodeCoordinates(n,2),NodeCoordinates(n,2)+0.25*maxi];
        plot(XL,YL,'linewidth',2)
    end
end
for i=2*NodeNum+1:3*NodeNum%rasme shekl baraye bargozarihaye langari
    B=[2*NodeNum+1:3*NodeNum];
    BAR=force(i);%BAR ra mosavi gharar bede ba meghdare derayeye i ome matrixe bargozari.
    if BAR~=0
        n=find(B==i);%n=find(a==k) yani az matrixe [a] shomareye an derayeh'i k barabar ba meghdare 'k' ast ra mosavi ba 'n' gharar bede{agar bejaye 'n' [m,n] bud yani satr va sotunash ra barabar ba betartib 'n' va 'm' gharar bede.mosallaman n barabar ba yeki az a'dade 1 ta NodeNum dar mi'ayad dar hamin khat zira in khat dar surati barrasi mishavad ke bar dar solse(1/3)ebteda'iye matrixe AllDof(dareje azadiha) bashad
        %rasme dayereh(kamane niruye langari)
        t=linspace(pi/6,4*pi/3,1000);
        h=NodeCoordinates(n,1);
        k=NodeCoordinates(n,2);
        r=0.15*maxi;
        x=r*cos(t)+h;
        y=r*sin(t)+k;
        plot(x,y,'linewidth',2)
        axis  square
    end
end

%matrixe sakhti (stiffness matrix)
stiffness=zeros(AllDof);%stiffness=matrixe sakhti , zeros(AllDof)=matrixe sefr ba satro sotuni barabar ba meghdare AllDof(tedad darajate azadi)
global Ke L;
Ke=zeros(6,ElementNum*6);
for e=1:ElementNum %meghdare e haman shomareye elemane morede nazar ast.
    E=EMatrix(e);
    A=AMatrix(e);
    I=IMatrix(e);
    EA=E*A;
    EI=E*I;
    ElementCourse=ElementNodes(e,:);%ElementCourse=ebteda va entehaye eleman(gerehye ebteda va gerehye entehaiye eleman)
    ElementDof=[ElementCourse ElementCourse+NodeNum ElementCourse+2*NodeNum];%elementDof:element degrees of freedom(az kolle darajate azadie sazeh,unai k marbut be elemane morede nazar mishan ro moshakhas mikone)
    xa=xx(ElementCourse(2))-xx(ElementCourse(1));%pishraviye elemani ke indice moshakhas karde dar jahate mehvare X ha(tule elemane mazkur dar rastaye mehvare X ha)
    ya=yy(ElementCourse(2))-yy(ElementCourse(1));%pishraviye elemani ke indice moshakhas karde dar jahate mehvare Y ha(tule elemane mazkur dar rastaye mehvare Y ha)
    length_element=sqrt(xa*xa+ya*ya);%tule elemane moshakhas shode dar indice ba estefade az ghaziyeye fisaghores
    cosa=xa/length_element;%cos=zel'e mojaver be zaviye/vatar(vatar haman tule eleman ast)
    sina=ya/length_element;%sin=zel'e moghabel be zaviye/vatar(vatar haman tule eleman ast)
    ll=length_element;
    L=[cosa*eye(2) sina*eye(2) zeros(2);-sina*eye(2) cosa*eye(2) zeros(2);zeros(2,4) eye(2)];%eye(2);matrixi morabba'i ba ab'ade 2*2 k drayehaye a11 va a22 ash 1 mibashand dorost mikonad.(eye(n,m):matrixi be ab'ade n*m k drayehaye a11,a22,...,ann ash (derayehaye ruye ghotre asliash) 1 mibashad va sayere derayehahash 0 mibashad)
    oneu=[1 -1;-1 1];
    oneu2=[1 -1;1 -1];
    oneu3=[1 1;-1 -1];
    oneu4=[4 2;2 4];
    k1=[EA/ll*oneu zeros(2,4);zeros(2) 12*EI/ll^3*oneu 6*EI/ll^2*oneu3
        zeros(2) 6*EI/ll^2*oneu2 EI/ll*oneu4];
    stiffness(ElementDof,ElementDof)=...
        stiffness(ElementDof,ElementDof)+L'*k1*L;%az matrixe stiffness k dar bala moarefi shod satrhaye motenazaer ba ElementDof va sotunhaye motenazer ba ElementDofra barabar gharar bade ba:khodeshun+L'*k1*L,va sayere derayeh hara bedune taghir baghi bogzar.  
    Ke(1:6,e*6-5:e*6)=k1;
end

% boundary conditions(sharayete marzi)
DeactivedDof=FRAMEINPUTES(1:U0Num,8);%DeactivedDof:matrixi shamele jabejaihai ke barabare sefr hastand

% anjame sayere mohasebat
activeDof=setdiff([1:AllDof]', [DeactivedDof]);%setdiff(A,B):anasori az bordare([matrixe] ya {majmueye}) A ra ke dar bordare B vojud nadarand neshan midahad.(az kolle darajate azadi anhai k 0 mishavand (DeactivedDof) ra kam mikonad va darajate azadiye gheyre sefr ra neshan midahad(moshakhas mikonad)
U=stiffness(activeDof,activeDof)\force(activeDof);
Displacements=zeros(AllDof,1);%matrixi sotuni ba te'dad satrhai barabar ba meghdare AllDof
Displacements(activeDof)=U;%az matrixe Displacements derayehaye motenazer ba matrixe activeDof ra mosavi ba maghadire matrixe U gharar midahad.

%namayeshe khorujihaye barnameh
global reactions
disp('***Displacement***')
NNode=1:AllDof;%NNode:yek matrix ba ab'ade 1*(tedade kolle daraje azadiha(AllDof))
[NNode' Displacements]
F=stiffness*Displacements; %F=KU
reactions=F(DeactivedDof);%az matrixe sotuniye F un satrhai k motenazer ba derayehaye matrixe DeactivedDof hastand ra birun mikeshim zira axol'amal faghat dar daraje azadihai k sefr mishavand(haman matrixe DeactivedDof) vojud darad.(be ebarate digar meghadare axol'amale tekyegahi dar daraje azadihaye 0 ro neshan midahad k haman matlube mas'aleye mast)
disp('***Reactions***')
[DeactivedDof reactions]

%Internal Forces
for p=1:ElementNum%in halghe baraye mohasebeye matrixe jabejaiye har eleman mibashad
    Ut=Displacements;
    Aa=Ut(1:NodeNum);%matrixe yeksevvome balaiye matrixe Ut(Ut matrixe jabejaiye kol mibashad).(marbut be jabejaihaye ofoghi ast)
    Bb=Ut(NodeNum+1:2*NodeNum);%matrixe yeksevvome miyaniye matrixe Ut(Ut matrixe jabejaiye kol mibashad).(marbut be jabejaihaye ghaem ast)
    Cc=Ut(2*NodeNum+1:3*NodeNum);%matrixe yeksevvome miyaniye matrixe Ut(Ut matrixe jabejaiye kol mibashad).(marbut be jabejaihaye ghaem ast)
    u1=Aa(ElementNodes(p,1));%jabejaiye ofoghi ruye gerehye ebtedaye har eleman
    u3=Bb(ElementNodes(p,1));%jabejaiye ghaem ruye gerehye ebtedaye har eleman
    u5=Cc(ElementNodes(p,1));%jabejaiye davarani ruye gerehye ebtedaye har eleman
    u2=Aa(ElementNodes(p,2));%jabejaiye ofoghi ruye gerehye entehaye har eleman
    u4=Bb(ElementNodes(p,2));%jabejaiye ghaem ruye gerehye entehaye har eleman
    u6=Cc(ElementNodes(p,2));%jabejaiye davarani ruye gerehye entehaye har eleman
    disp('Internal Force,Stiffness and Displacement Matrix For Element');disp(p)
    ue=[u1;u2;u3;u4;u5;u6]%matrixe jabejaiye har eleman
    y1=(NodeCoordinates(ElementNodes(p,1),2));%az satre 292 ta 295 baraye ineke bebinim eleman ofoghi ast ya na,zira agar ofoghi bashad nabayad matrixe tabdil(L) ra dar matrixe sakhtiash asar dad vali dar gheyre in surat bayad matrixe tabdil(L) dar matrixe sakhtie eleman asar konad(in tozihat faghat baraye masaele Frame mo'tabar ast va hamntor k moshahede mikonid baraye masaele Truss vojud nadarad)
    y2=(NodeCoordinates(ElementNodes(p,2),2));
    y2y1=y2-y1;%ekhtelafe moalefehaye y e node enteha(y2) va node ebteda(y1) 
    if y2y1==0
    ke=Ke(1:6,p*6-5:p*6)
    else
    ke=L'*Ke(1:6,p*6-5:p*6)*L%matrixe sakhtiye har eleman [ke] k az matrixe [Ke] k matrix sakhtihaye hameye elemanha ra dar khod zakhire karde bud birun mikeshim va dar matrixe tabdile L va taranahadash zarb mikonim
    end
    fe=ke*ue%matrixe niruhaye dakheliye har eleman
    disp('- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -')
end
disp('A N A L Y S I S   C O M P L E T E ')
disp(datestr(clock))
save('Frame Displacements.txt','Displacements','-ascii')
save('Frame Reactions.txt','reactions','-ascii')
else
    disp ' '
    disp '!!!  Error:Your Answer Is Incorrect,Please Try Again  !!!'
end
